unit Diagtype;

interface

const
  {------------------ Chess Stuff -------------------}
  // chess pieces
  kBlackKing   = 12;
  kBlackQueen  = 11;
  kBlackRook   = 10;
  kBlackBishop = 9;
  kBlackKnight = 8;
  kBlackPawn   = 7;

  kWhiteKing   = 6;
  kWhiteQueen  = 5;
  kWhiteRook   = 4;
  kWhiteBishop = 3;
  kWhiteKnight = 2;
  kWhitePawn   = 1;

  kEmptySquare = 0;


  // chessboard squares
  // 1st rank
  kA1Square =  0;
  kB1Square =  1;
  kC1Square =  2;
  kD1Square =  3;
  kE1Square =  4;
  kF1Square =  5;
  kG1Square =  6;
  kH1Square =  7;

  // 2nd rank
  kA2Square = 10;
  kB2Square = 11;
  kC2Square = 12;
  kD2Square = 13;
  kE2Square = 14;
  kF2Square = 15;
  kG2Square = 16;
  kH2Square = 17;

  // 3rd rank
  kA3Square = 20;
  kB3Square = 21;
  kC3Square = 22;
  kD3Square = 23;
  kE3Square = 24;
  kF3Square = 25;
  kG3Square = 26;
  kH3Square = 27;

  // 4th rank
  kA4Square = 30;
  kB4Square = 31;
  kC4Square = 32;
  kD4Square = 33;
  kE4Square = 34;
  kF4Square = 35;
  kG4Square = 36;
  kH4Square = 37;

  // 5th rank
  kA5Square = 40;
  kB5Square = 41;
  kC5Square = 42;
  kD5Square = 43;
  kE5Square = 44;
  kF5Square = 45;
  kG5Square = 46;
  kH5Square = 47;

  // 6th rank
  kA6Square = 50;
  kB6Square = 51;
  kC6Square = 52;
  kD6Square = 53;
  kE6Square = 54;
  kF6Square = 55;
  kG6Square = 56;
  kH6Square = 57;

  // 7th rank
  kA7Square = 60;
  kB7Square = 61;
  kC7Square = 62;
  kD7Square = 63;
  kE7Square = 64;
  kF7Square = 65;
  kG7Square = 66;
  kH7Square = 67;

    // 8th rank
  kA8Square = 70;
  kB8Square = 71;
  kC8Square = 72;
  kD8Square = 73;
  kE8Square = 74;
  kF8Square = 75;
  kG8Square = 76;
  kH8Square = 77;


type
    { 0..15 contains packed piece placement }
    { 16 contains bit flags for castling rights, }
    { en passant square, etc.   Total size is 34 bytes. }

  ChessBoardType = array [0..16] of Word;
  PChessBoardType = ^ChessBoardType;

  SquareType = -21..98;

  DiacriticType = 1..7;

  PieceType = kEmptySquare..kBlackKing;

  ChessMoveType = record
    FromSquare, ToSquare : SquareType;
    PromotionPiece       : PieceType;
    Diacritic            : Diacritictype;
    MovePiece            : PieceType;
    CapturePiece         : Piecetype; {Sera kemptysquare si no hay captura}
    flags                : byte;
    Enpassant            : boolean;
    EnJaque              : boolean;
    Enroque              : boolean;
    reserved2            : boolean;
    end;

  PChessMoveType = ^ChessMoveType;


implementation

end.
